FROM node:20-alpine AS base

# Change Alpine repo
RUN sed -i 's|https://dl-cdn.alpinelinux.org/alpine|https://mirror.de.velop.ir/alpine|g' /etc/apk/repositories

# Configure npm registry mirror (Liara)
ENV NPM_CONFIG_REGISTRY=https://mirror-npm.runflare.com
RUN npm config set registry https://mirror-npm.runflare.com

# Install tzdata to support timezone settings
# RUN apk add --no-cache tzdata && \
#     cp /usr/share/zoneinfo/Asia/Tehran /etc/localtime && \
#     echo "Asia/Tehran" > /etc/timezone

WORKDIR /app

FROM base AS deps
RUN apk add --no-cache libc6-compat git
COPY package*.json ./
RUN npm ci --legacy-peer-deps --ignore-scripts --loglevel info

FROM base AS builder
WORKDIR /build
COPY --from=deps /app/node_modules ./node_modules
COPY . .
RUN npm run build && npm ci --omit=dev --legacy-peer-deps --ignore-scripts --loglevel info

FROM base AS runner
WORKDIR /app

ENV NODE_ENV=production
ENV NEXT_TELEMETRY_DISABLED=1

RUN addgroup -S appgroup && adduser -S appuser -G appgroup
RUN mkdir .next && chown appuser:appgroup .next

COPY --from=builder --chown=appuser:appgroup /build/.next/standalone ./
COPY --from=builder --chown=appuser:appgroup /build/.next/static ./.next/static
COPY --from=builder --chown=appuser:appgroup /build/public ./public
COPY --from=builder --chown=appuser:appgroup /build/package.json ./package.json

USER appuser

EXPOSE 3000
ENV PORT=3000
ENV HOSTNAME="0.0.0.0"
ENV NEXT_PUBLIC_API_BASE_URL=https://api.danakcorp.com/

CMD ["node", "server.js"]